Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Core Plugins Estimated time: 0.00 hour

Target version: 3.4.0   

Resolution: Fixed   

Description

After updating to Redmine 3.3 we began to encounter broken issue trees quite often. Root and parent ids are ok, but lft and rgt

values get messed up somehow. We have ~250k issues so using Issue.rebuild_tree! is a rather expensive task with enormous

overhead as 99.99% of nested sets are ok and it is usually one or two that get broken from time to time.

I suppose having a possibility to rebuild only a single nested set would be very useful in such situations. Below is the code I'm using

to do so now - just added it to /lib/redmine/nested_set/issue_nested_set.rb

def rebuild_single_tree!(root_id)

  root = Issue.find(root_id)

  if root.blank? || !root.parent_id.blank?

    p "Wrong root specified" 

    return

  end

  transaction do           

    where(root_id: root_id).update_all(:lft => nil, :rgt => nil)

    where(root_id: root_id, parent_id: nil).update_all(["lft = ?, rgt = ?", 1, 2])

    rebuild_nodes(root_id)    

  end

end

Associated revisions

Revision 16111 - 2016-12-21 11:35 - Jean-Philippe Lang

Adds .rebuild_single_tree! to rebuild a single tree (#24167).

History

#1 - 2016-10-25 20:23 - Warren Postma

Wouldn't it be nice if Redmine moved to Git and you could just log an MR instead of pasting code or uploading a .patch? Le Sigh.

#14961

#2 - 2016-10-25 20:36 - Toshi MARUYAMA

- Description updated

#3 - 2016-10-25 20:43 - Toshi MARUYAMA

- Target version set to 3.4.0

#4 - 2016-12-21 11:35 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Feature added in r16111.

Powered by TCPDF (www.tcpdf.org)

2025-05-17 1/1

https://www.redmine.org/issues/14961
https://www.redmine.org/projects/redmine/repository/svn/revisions/16111
http://www.tcpdf.org

